import xOffsetUpdate from './x-offset-update';

const genResizeHandler = pstate =>
    (width, height) => {
        let { xOffset, yOffset, xScale, yStep, time, sidebarWidth, numLanes } = pstate;
        pstate.width = width;

        // TODO: 此处用于管理 波形渲染区域 的整体方位
        // 真实高度还要减去 上方 toolbar 的高度
        // 此处的 60 为 --toolbar-height
        pstate.height = height - 55;

        // Y
        const yOffsetMax = (numLanes + 2) * 2 * yStep;
        if (yOffsetMax < 0) {
            yOffset = 0;
        } else if (yOffset > yOffsetMax) {
            yOffset = yOffsetMax;
        }
        pstate.yOffset = yOffset;

        const xScaleMin = pstate.xScaleMin = 0.001;
        pstate.xScale = (xScale < xScaleMin) ? xScaleMin : xScale;
        xOffsetUpdate(pstate, () => xOffset);
    };

export default genResizeHandler;
